unit Eliza_Main;

{$MODE Delphi}

{History notes :
- Joseph Weizenbaum (MIT) had wrote the first version of Eliza near 1966.
- rewrited for Windows / Delphi 4 in March 2006 by Chris FERON http://chrisferon.free.fr/
   Enjoy!
   Christian FERON. }

interface

uses
  LCLIntf, LCLType, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, Buttons;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Label1: TLabel;
    EditInput: TEdit;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    About1: TMenuItem;
    About2: TMenuItem;
    Edition1: TMenuItem;
    Copy1: TMenuItem;
    LabelKeyword: TLabel;
    Format1: TMenuItem;
    Backgroundcolor1: TMenuItem;
    Fontcolor1: TMenuItem;
    ColorDialog1: TColorDialog;
    N1: TMenuItem;
    Normalscreen1: TMenuItem;
    DOSscreen1: TMenuItem;
    Button: TBitBtn;
    Image1: TImage;
    //***** INTERFACE *****
    procedure FormShow(Sender: TObject);
    procedure VarInit;
    procedure Memo1KeyPress(Sender: TObject; var Key: Char);
    procedure FormResize(Sender: TObject);
    procedure About2Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Backgroundcolor1Click(Sender: TObject);
    procedure Fontcolor1Click(Sender: TObject);
    procedure Normalscreen1Click(Sender: TObject);
    procedure DOSscreen1Click(Sender: TObject);
    //***** EXEC *****
    procedure RunClick(Sender: TObject);
    function TrimStr(S: String): String;
    function CleanStr(S: String): String;
    function FindKey(OutputStr: String; var KeyWordPos, KeyNum: Word): Boolean;
    function SwapSentence(var InputStr, OutputStr: String; KeyWordPos: Word): Boolean;
    function PosFirstConjonction(S: String): Word;
    procedure GetResponse(var OutputStr: String; KeyNum, KeyWordPos: Word);
    function ReadResponse(RespNum: Word): String;
    function UpperCaseFirstChar(S: ShortString): ShortString;
    procedure PrintUserQuestion(S: String);
    procedure PrintElizaAsk(S: String);

  private
  { Déclarations privées }
  public
  { Déclarations publiques }
  KeyWords : array [0..37] of String[15];
  KeyIndex : array [1..2] of array [0..37] of Word;
  ResponseIndex : array[1..37] of Word;
  Conj1, Conj2 : array[1..15] of String[15];
  MaxKey : Word;
  ResponseFile : String[50];
  MaxRespNum : Word;
  NoFileMsg, LogicErrMsg : ShortString;
  MaxConj : Word;
  MemoInput : ShortString;
  MemoResponseIndex : Word;

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

//***** INTERFACE *************************************************************
procedure TForm1.FormShow(Sender: TObject);
begin
//Init :
 VarInit;
 LabelKeyword.Caption := '';
 {- misc error messages -}
 NoFileMsg := 'Sorry, I seem to have mis-placed the response files.';
 LogicErrMsg := 'Hmmm, I seem to be having problems myself.';

//Memo1 :
 with Memo1 do begin
  Clear;
  Lines.Add('');
  //Paragraph.Alignment := taCenter;
  Lines.Add('¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤');
  //SelAttributes.Style := SelAttributes.Style + [fsBold];
  //SelAttributes.Size := 10;
  Lines.Add('              ~  ELIZA rogerian therapist  ~');
  //SelAttributes.Size := 8;
  Lines.Add('( Joseph Weizenbaum, 1966 - Chris Feron, 2006 )');
  //SelAttributes.Style := SelAttributes.Style - [fsBold];
  Lines.Add('¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤');
  Lines.Add('');
  Lines.Add('');
  //Paragraph.Alignment := taLeftJustify;
  //ParaGraph.FirstIndent := 5;
  //SelAttributes.Style := SelAttributes.Style + [fsBold];
  Lines.Add('Hello! I''m Eliza.');
  //SelAttributes.Style := SelAttributes.Style + [fsBold];
  Lines.Add('Our conversation will not be recorded. So, you can speak to me freely.');
  //SelAttributes.Style := SelAttributes.Style + [fsBold];
  Lines.Add('Please tell me about your problems.');
  //SelAttributes.Style := SelAttributes.Style - [fsBold];
  Lines.Add('');
  end;//End with...
 EditInput.SetFocus;
end;

procedure TForm1.VarInit;
var
 I : Word;
begin
 ResponseFile := 'RESPONSE.DAT';//Script response File
 MaxRespNum := 116;
 MemoInput := '';
 MemoResponseIndex := 0;

//Keywords :
 MaxKey := High(KeyWords);
{- StartIndex : KeyIndex[1,1]. EndIndex : KeyIndex[2,1]}
 KeyWords[1] := 'can you'; KeyIndex[1,1] := 1; KeyIndex[2,1] := 3;
 KeyWords[2] := 'can i'; KeyIndex[1,2] := 4; KeyIndex[2,2] := 5;
 KeyWords[3] := 'you are'; KeyIndex[1,3] := 6; KeyIndex[2,3] := 9;
 KeyWords[4] := 'you''re'; KeyIndex[1,4] := 6; KeyIndex[2,4] := 9;
 KeyWords[5] := 'i don''t'; KeyIndex[1,5] := 10; KeyIndex[2,5] := 13;
 KeyWords[6] := 'i feel'; KeyIndex[1,6] := 14; KeyIndex[2,6] := 16;
 KeyWords[7] := 'why don''t you'; KeyIndex[1,7] := 17; KeyIndex[2,7] := 19;
 KeyWords[8] := 'why can''t i'; KeyIndex[1,8] := 20; KeyIndex[2,8] := 21;
 KeyWords[9] := 'are you'; KeyIndex[1,9] := 22; KeyIndex[2,9] := 24;
 KeyWords[10] := 'i can''t'; KeyIndex[1,10] := 25; KeyIndex[2,10] := 27;

 KeyWords[11] := 'i am'; KeyIndex[1,11] := 28; KeyIndex[2,11] := 31;
 KeyWords[12] := 'i''m'; KeyIndex[1,12] := 28; KeyIndex[2,12] := 31;
 KeyWords[13] := 'you'; KeyIndex[1,13] := 32; KeyIndex[2,13] := 34;
 KeyWords[14] := 'i want'; KeyIndex[1,14] := 35; KeyIndex[2,14] := 39;
 KeyWords[15] := 'what'; KeyIndex[1,15] := 40; KeyIndex[2,15] := 48;
 KeyWords[16] := 'how'; KeyIndex[1,16] := 40; KeyIndex[2,16] := 48;
 KeyWords[17] := 'who'; KeyIndex[1,17] := 40; KeyIndex[2,17] := 48;
 KeyWords[18] := 'where'; KeyIndex[1,18] := 40; KeyIndex[2,18] := 48;
 KeyWords[19] := 'when'; KeyIndex[1,19] := 40; KeyIndex[2,19] := 48;
 KeyWords[20] := 'why'; KeyIndex[1,20] := 40; KeyIndex[2,20] := 48;

 KeyWords[21] := 'name'; KeyIndex[1,21] := 49; KeyIndex[2,21] := 50;
 KeyWords[22] := 'cause'; KeyIndex[1,22] := 51; KeyIndex[2,22] := 54;
 KeyWords[23] := 'sorry'; KeyIndex[1,23] := 55; KeyIndex[2,23] := 58;
 KeyWords[24] := 'dream'; KeyIndex[1,24] := 59; KeyIndex[2,24] := 62;
 KeyWords[25] := 'hello'; KeyIndex[1,25] := 63; KeyIndex[2,25] := 63;
 KeyWords[26] := 'hi '; KeyIndex[1,26] := 63; KeyIndex[2,26] := 63;
 KeyWords[27] := 'maybe'; KeyIndex[1,27] := 64; KeyIndex[2,27] := 68;
 KeyWords[28] := 'no '; KeyIndex[1,28] := 69; KeyIndex[2,28] := 73;
 KeyWords[29] := 'your '; KeyIndex[1,29] := 74; KeyIndex[2,29] := 75;
 KeyWords[30] := 'always'; KeyIndex[1,30] := 76; KeyIndex[2,30] := 79;

 KeyWords[31] := 'think'; KeyIndex[1,31] := 80; KeyIndex[2,31] := 82;
 KeyWords[32] := 'alike'; KeyIndex[1,32] := 83; KeyIndex[2,32] := 89;
 KeyWords[33] := 'yes'; KeyIndex[1,33] := 90; KeyIndex[2,33] := 92;
 KeyWords[34] := ' friend'; KeyIndex[1,34] := 93; KeyIndex[2,34] := 98;
 KeyWords[35] := 'computer'; KeyIndex[1,35] := 99; KeyIndex[2,35] := 105;
 KeyWords[36] := 'no key found'; KeyIndex[1,36] := 106; KeyIndex[2,36] := 112;
 KeyWords[37] := 'repeat input'; KeyIndex[1,37] := 113; KeyIndex[2,37] := 116;

 MaxConj := 15;
 Conj1[2]  := ' am ';   	Conj2[2]  := ' are ';
 Conj1[4]  := ' was ';  	Conj2[4]  := ' were ';
 Conj1[5]  := ' I ';    	Conj2[5]  := ' you ';
 Conj1[6]  := ' me ';    	Conj2[6]  := ' you ';
 Conj1[8]  := ' my ';    	Conj2[8]  := ' your ';
 Conj1[10] := ' I''m ';   	Conj2[10] := ' you''re ';
 Conj1[11] := ' I''ve ';  	Conj2[11] := ' you''ve ';
 Conj1[14] := ' myself '; 	Conj2[14] := ' yourself ';

{- start the index array -}
  for I := 1 to MaxKey do
  ResponseIndex[I] := KeyIndex[1,I];
end;

procedure TForm1.Memo1KeyPress(Sender: TObject; var Key: Char);
begin
 Key := Char(#0);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
 Memo1.Refresh;
end;

procedure TForm1.About2Click(Sender: TObject);
begin
 ShowMessage(
  'Win Eliza Example version 1.0 for Windows by Christian Feron (2006).' + Chr(13) +
  'For students or developpers, the source code of this software is available on my website (http://chrisferon.free.fr). Enjoy !' + Chr(13) + Chr(13) +
  '(The first script of Eliza Program was written by Joseph WEIZENBAUM (M.I.T) near 1966.)');
end;

procedure TForm1.Copy1Click(Sender: TObject);
begin
if Memo1.Text <> '' then begin
  Memo1.SelectAll;
  Memo1.CopyToClipBoard;
 end;
 EditInput.SetFocus;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.Backgroundcolor1Click(Sender: TObject);
begin
 if ColorDialog1.Execute then Memo1.Color :=  ColorDialog1.Color;
end;

procedure TForm1.Fontcolor1Click(Sender: TObject);
begin
 if ColorDialog1.Execute then Memo1.Font.Color :=  ColorDialog1.Color;
end;

procedure TForm1.Normalscreen1Click(Sender: TObject);
begin
 Memo1.Color :=  clWhite;
 Memo1.Font.Color :=  clBlack;
end;

procedure TForm1.DOSscreen1Click(Sender: TObject);
begin
 Memo1.Color :=  clBlack;
 Memo1.Font.Color :=  clLime;
end;

//***** EXEC ******************************************************************
procedure TForm1.RunClick(Sender: TObject);
var
 KeyNum, KeyWordPos : Word;
 InputStr, OutputStr: String;
begin
//Init :
 KeyWordPos := 0;
 KeyNum := 0;

 if EditInput.Text = '' then begin
  {PrintUserQuestion('...');
  PrintElizaAsk('Please talk. I can''t help you without a dialog!');}
  EditInput.SetFocus;
  Exit;
  end;

 InputStr := TrimStr(EditInput.Text);

 PrintUserQuestion(InputStr);
 EditInput.Text := '';

 OutputStr := LowerCase(InputStr);

 KeyNum := MaxKey;

 if OutputStr <> MemoInput then begin //If not repeat

  if FindKey(OutputStr, KeyWordPos, KeyNum)
   then GetResponse(OutputStr,KeyNum,KeyWordPos)
    else
      if SwapSentence(InputStr,OutputStr,KeyWordPos)
       then OutputStr := OutputStr
       else GetResponse(OutputStr,KeyNum,KeyWordPos);

 end else GetResponse(OutputStr,KeyNum,KeyWordPos);//If repeat

 MemoInput := LowerCase(InputStr);

 OutputStr := UpperCaseFirstChar(OutputStr);
 PrintElizaAsk(OutputStr);

 if Length(Memo1.Lines.Text) > 30000 then Memo1.Lines.Delete(0);

 EditInput.SetFocus;
end;

function TForm1.TrimStr(S: String): String;
begin
 Result := TrimRight(TrimLeft(S));
end;

function TForm1.CleanStr(S: String): String;
begin
 S := TrimStr(S);
 if S[Length(S)] in ['.','?','!',';',':','/','\','#'] then
    Delete(S,Length(S),1);
 Result := S;
end;

function TForm1.FindKey(OutputStr: String; var KeyWordPos, KeyNum: Word): Boolean;
label
 Found;
begin
  KeyNum := 0;
  while KeyNum < Pred(MaxKey) do begin
    Inc(KeyNum);
    KeyWordPos := Pos(KeyWords[KeyNum],OutputStr);

    if KeyWordPos > 0 then goto Found;
  end;//End while...

  Result := False;
  Exit;

Found:
  KeyWordPos := KeyWordPos + Length(KeyWords[KeyNum]);
  Result := True;
end;

function TForm1.SwapSentence(var InputStr, OutputStr: String; KeyWordPos: Word): Boolean;
var
 I, Cpt : Word;
begin
 Result := False;
 KeyWordPos := PosFirstConjonction(OutputStr);
 if KeyWordPos=0 then Exit;//if nothing is found

 OutputStr := Copy(InputStr,KeyWordPos,Length(InputStr));
 if Length(OutputStr) = 0 then OutputStr := InputStr;

{- parse the string -}
 for I := 1 to MaxConj do begin
   Cpt := 0;
  while Cpt < Length(OutputStr) do begin
    Inc(Cpt);
    if Pos(Conj1[I], OutputStr) > 0 then begin
       OutputStr := StringReplace(OutputStr,Conj1[I], Conj2[I],[]);
       Result := True;
       end;//End if...
  end;//End while...
 end;//End for...

    Cpt := 1;
 while Cpt < Length(OutputStr) do
   if OutputStr[Cpt] = '!' then Delete(OutputStr,Cpt,1) else Inc(Cpt);
 TrimStr(OutputStr);

 if OutputStr[1]=' ' then Delete(OutputStr,1,1);

 if OutputStr[Length(OutputStr)] = 'I' then begin
  Delete(OutputStr, Length(OutputStr), 1);
  OutputStr := OutputStr + 'me';
 end;//End if...
end;

function TForm1.PosFirstConjonction(S: String): Word;
var
 I, Min, Posi : Word;
begin
    Posi := 65535;//Max of Word
{- parse the string to localize the first conjonction -}
 for I := 1 to MaxConj do begin
   if Pos(Conj1[I], S) > 0 then begin
      Min := Pos(Conj1[I], S);
      if Posi > Min then Posi := Min;
   end;//End if...
 end;//End for I...
 if Posi = 65535
  then Result := 0 //Returns 0 if nothing found
  else Result := Posi;
end;

procedure TForm1.GetResponse(var OutputStr: String; KeyNum, KeyWordPos: Word);
var
 ResponseStr : String;
label Append_01,Append_02;
begin
 if MemoResponseIndex = ResponseIndex[KeyNum] then Inc(ResponseIndex[KeyNum]);
 MemoResponseIndex := ResponseIndex[KeyNum];

 ResponseStr := ReadResponse(ResponseIndex[KeyNum]);

  {--- Keyword test : ---}
  {LabelKeyword.Caption := 'Eliza current keyword : ' + KeyWords[KeyNum]
                             + '. Key number : ' + IntToStr(KeyNum)
                             + '. ResponseIndex : ' + IntToStr(ResponseIndex[KeyNum]);}

  if ResponseIndex[KeyNum] > KeyIndex[2,KeyNum] then ResponseIndex[KeyNum] := KeyIndex[1,KeyNum];

  if ResponseStr[Length(ResponseStr)] = '*' then goto Append_01;
  if ResponseStr[Length(ResponseStr)] = '@' then goto Append_02;
  OutputStr := ResponseStr;
  Exit;

 Append_01:
   ResponseStr[Length(ResponseStr)] := ' ';
   OutputStr := Copy(OutputStr,KeyWordPos,Length(OutputStr));
   OutputStr := CleanStr(OutputStr);
   OutputStr := ResponseStr + OutputStr + '?';
   Exit;

 Append_02:
   ResponseStr[Length(ResponseStr)] := ' ';
   OutputStr := Copy(OutputStr,KeyWordPos,Length(OutputStr));
   OutputStr := CleanStr(OutputStr);
   OutputStr := ResponseStr + OutputStr + '.';
end;

function TForm1.ReadResponse(RespNum: Word): String;
var
 I : Integer;
 F : TextFile;
label NoFileErr,LogicErr;
begin
  if (RespNum = 0) or (RespNum > MaxRespNum) then goto LogicErr;

{$I-}
  AssignFile(F,ResponseFile);
  reset(F);
  for I := 1 to Pred(RespNum) do
     Readln(F);

     Readln(F,Result);
     CloseFile(F);

{$I+}
  if IOResult <> 0 then goto NoFileErr;
  Exit;

NoFileErr:
  Result := NoFileMsg;
  Exit;

LogicErr:
  Result := LogicErrMsg;
end;

function TForm1.UpperCaseFirstChar(S: ShortString): ShortString;
var
 M : String[2];
begin
  M := ''; Result := '';
  M := UpperCase(S[1]);
  S := StringReplace(S,S[1],M,[]);
  Result := S;
end;

procedure TForm1.PrintUserQuestion(S: String);//New - March 2006
begin
 with Memo1 do begin
  //ParaGraph.FirstIndent := 5;
  Lines.Add('USER: ' + S);//Print the response
 end;//End with...
 SendMessage(Memo1.Handle, EM_SCROLLCARET, 0, 0);
end;

procedure TForm1.PrintElizaAsk(S: String);//New - March 2006
begin
 with Memo1 do begin
  //ParaGraph.FirstIndent := 5;
  //SelAttributes.Style := SelAttributes.Style + [fsBold];
  Lines.Add('ELIZA: ' + S);//Print the response
  //SelAttributes.Style := SelAttributes.Style - [fsBold];
 end;//End with...
 SendMessage(Memo1.Handle, EM_SCROLLCARET, 0, 0);
end;

end.
